/*
 * Userlist functions and definitions.
 * Copyright Colten Edwards 1996
 * 
 */
 
#ifndef _user_list_h
#define _user_list_h

void add_shit _((char *, char *, char *, char *));
void add_user _((char *, char *, char *, char *));
void showuserlist _((char *, char *, char *, char *));
void change_user _((char *, char *, char *, char *));
void savelists _((char *, char *, char *, char *));

void add_to_a_list _((char *, int, char *, char *, char *, int));
void showlist _((NickList *, char *));
UserList *lookup_userlevelc _((char *, char *, char *, char *));

UserList *nickinuser _((char *, char *));
ShitList *nickinshit _((char *, char *));

int	find_user_level _((char *, char *, char *));
int	find_shit_level _((char *, char *, char *));

NickList *check_auto _((char *, NickList *, ChannelList *));
int check_prot _((char *, char *, ChannelList *, BanList *, NickList *));
void check_shit _((ChannelList *));
void check_hack _((char *, ChannelList *, NickList *, char *));
int check_channel_match _((char *, char *));
int delay_check_auto _((char *));


extern ShitList *shitlist_list;
extern LameList *lame_list;
extern WordKickList *ban_words;

#define USERLIST_REMOVE 0
#define USERLIST_ADD 1
#define SHITLIST_ADD 11
#define SHITLIST_REMOVE 12

#define ADD_VOICE	0x0001
#define ADD_OPS		0x0002
#define ADD_BAN		0x0004
#define ADD_UNBAN	0x0008
#define ADD_INVITE	0x0010
#define ADD_DCC		0x0020
#define ADD_KILL	0x0040
#define ADD_IOPS	0x0080
#define ADD_FLOOD	0x0100
#define ADD_BOT		0x0200

#define PROT_REOP	0x0400
#define PROT_DEOP	0x0800
#define PROT_KICK	0x1000
#define PROT_BAN	0x2000
#define PROT_INVITE	0x4000

#define ADD_FRIEND	(ADD_VOICE|ADD_OPS|ADD_UNBAN|ADD_INVITE)
#define ADD_MASTER	(ADD_VOICE|ADD_OPS|ADD_BAN|ADD_UNBAN|ADD_INVITE|ADD_DCC|ADD_FLOOD)
#define ADD_OWNER	(ADD_MASTER|ADD_KILL|ADD_BOT)
#define PROT_ALL	(PROT_REOP|PROT_DEOP|PROT_KICK|PROT_BAN|PROT_INVITE)

#define SHIT_NOOP	0x0001
#define SHIT_KICK	0x0002
#define SHIT_KICKBAN	0x0004
#define SHIT_PERMBAN	0x0008
#define SHIT_IGNORE	0x0010

/* user.c functions for dealing with hashed userlist */
UserList *find_bestmatch(char *, char *, char *, char *);
char * convert_flags(unsigned int flags);
UserList *find_userlist(char *, char *, int);
void add_userlist(UserList *);
UserList *next_userlist(UserList *, int *, void **);
void destroy_sorted_userlist(UserList **);
UserList *create_sorted_userlist(void);
char *convert_flags_to_str(unsigned int);
unsigned int convert_str_to_flags(char *);

#endif

